Getting Started with CardView Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the CardView module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.cardview.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-card-view id="cardview"></smart-card-view>

    Host container (id matches appendTo on Smart.CardView):

    <div id="cardviewContainer"></div>

  5. Initialize after the module loads: define a const cardviewOptions object, then either bind with Smart('#cardview', ...) on the semantic tag or use new Smart.CardView({ ...cardviewOptions, appendTo: '#cardviewContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.cardview.js';
    
    	const cardviewOptions = {
    				dataSource: new Smart.DataAdapter({
    					dataSource: (function generateData(length) {
    						const sampleData = [], firstNames = ['Andrew', 'Nancy', 'Shelley', 'Regina', 'Yoshi', 'Antoni', 'Mayumi', 'Ian', 'Peter', 'Lars', 'Petra', 'Martin', 'Sven', 'Elio', 'Beate', 'Cheryl', 'Michael', 'Guylene'], lastNames = ['Fuller', 'Davolio', 'Burke', 'Murphy', 'Nagase', 'Saavedra', 'Ohno', 'Devling', 'Wilson', 'Peterson', 'Winkler', 'Bein', 'Petersen', 'Rossi', 'Vileid', 'Saylor', 'Bjorn', 'Nodier'], petNames = ['Sam', 'Bob', 'Lucky', 'Tommy', 'Charlie', 'Olliver', 'Mixie', 'Fluffy', 'Acorn', 'Beak'], countries = ['Bulgaria', 'USA', 'UK', 'Singapore', 'Thailand', 'Russia', 'China', 'Belize'], productNames = ['Black Tea', 'Green Tea', 'Caffe Espresso', 'Doubleshot Espresso', 'Caffe Latte', 'White Chocolate Mocha', 'Cramel Latte', 'Caffe Americano', 'Cappuccino', 'Espresso Truffle', 'Espresso con Panna', 'Peppermint Mocha Twist'];
    						for (let i = 0; i < length; i++) {
    							const row = {};
    							row.firstName = firstNames[Math.floor(Math.random() * firstNames.length)];
    							row.lastName = lastNames[Math.floor(Math.random() * lastNames.length)];
    							row.birthday = new Date(Math.round(Math.random() * (2026 - 1926) + 1926), Math.round(Math.random() * 11), Math.round(Math.random() * (31 - 1) + 1));
    							row.petName = petNames[Math.floor(Math.random() * petNames.length)];
    							row.country = countries[Math.floor(Math.random() * countries.length)];
    							row.productName = productNames[Math.floor(Math.random() * productNames.length)];
    							row.price = parseFloat((Math.random() * (100 - 0.5) + 0.5).toFixed(2));
    							row.quantity = Math.round(Math.random() * (50 - 1) + 1);
    							row.timeOfPurchase = new Date(2026, 0, 1, Math.round(Math.random() * 23), Math.round(Math.random() * (31 - 1) + 1));
    							row.expired = Math.random() >= 0.5;
    							row.attachments = [];
    							const maxAttachments = Math.floor(Math.random() * Math.floor(3)) + 1;
    							for (let i = 0; i < maxAttachments; i++) {
    								row.attachments.push("../../../images/travel/7.jpg");
    							}
    							row.attachments = row.attachments.join(',');
    							sampleData[i] = row;
    						}
    						return sampleData;
    					}(50)),
    					dataFields: [
    						'firstName: string',
    						'lastName: string',
    						'birthday: date',
    						'petName: string',
    						'country: string',
    						'productName: string',
    						'price: number',
    						'quantity: number',
    						'timeOfPurchase: date',
    						'expired: boolean',
    						'attachments: string'
    					]
    				}),
    				columns: [
    					{ label: 'First Name', dataField: 'firstName', icon: 'firstName' },
    					{ label: 'Last Name', dataField: 'lastName', icon: 'lastName' },
    					{ label: 'Birthday', dataField: 'birthday', icon: 'birthday', formatSettings: { formatString: 'd' } },
    					{ label: 'Pet Name', dataField: 'petName', icon: 'petName' },
    					{ label: 'Country', dataField: 'country', icon: 'country' },
    					{ label: 'Product Name', dataField: 'productName', icon: 'productName' },
    					{ label: 'Price', dataField: 'price', icon: 'price', formatSettings: { formatString: 'c2' } },
    					{
    						label: 'Quantity', dataField: 'quantity', icon: 'quantity'
    					},
    					{ label: 'Time of Purchase', dataField: 'timeOfPurchase', icon: 'timeOfPurchase', formatSettings: { formatString: 'hh:mm tt' } },
    					{
    						label: 'Expired', dataField: 'expired', icon: 'expired', formatFunction: function (settings) {
    							settings.template = settings.value ? '☑' : '☐';
    						}
    					},
    					{ label: 'Attachments', dataField: 'attachments', image: true }
    				],
    				coverField: 'attachments',
    				titleField: 'firstName'
    			};
    
    	// Option A - semantic <smart-card-view> with id="cardview"
    	Smart('#cardview', class {
    		get properties() {
    			return cardviewOptions;
    		}
    	});
    
    	// Option B - host div id="cardviewContainer"
    	// const cardviewInstance = new Smart.CardView({
    	// 	...cardviewOptions,
    	// 	appendTo: '#cardviewContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myCardView = new Smart.CardView('#cardview', cardviewOptions);
    	// document.body.appendChild(myCardView);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.CardView('#cardview', cardviewOptions) with appendChild, and document.createElement('smart-card-view') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.CardView({ ...options, appendTo: '#...' }); new Smart.CardView('#cardview', cardviewOptions) plus appendChild on the returned element; and document.createElement('smart-card-view') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myCardView = new Smart.CardView('#cardview', cardviewOptions)):

	const cardviewOptions = {
				dataSource: new Smart.DataAdapter({
					dataSource: (function generateData(length) {
						const sampleData = [], firstNames = ['Andrew', 'Nancy', 'Shelley', 'Regina', 'Yoshi', 'Antoni', 'Mayumi', 'Ian', 'Peter', 'Lars', 'Petra', 'Martin', 'Sven', 'Elio', 'Beate', 'Cheryl', 'Michael', 'Guylene'], lastNames = ['Fuller', 'Davolio', 'Burke', 'Murphy', 'Nagase', 'Saavedra', 'Ohno', 'Devling', 'Wilson', 'Peterson', 'Winkler', 'Bein', 'Petersen', 'Rossi', 'Vileid', 'Saylor', 'Bjorn', 'Nodier'], petNames = ['Sam', 'Bob', 'Lucky', 'Tommy', 'Charlie', 'Olliver', 'Mixie', 'Fluffy', 'Acorn', 'Beak'], countries = ['Bulgaria', 'USA', 'UK', 'Singapore', 'Thailand', 'Russia', 'China', 'Belize'], productNames = ['Black Tea', 'Green Tea', 'Caffe Espresso', 'Doubleshot Espresso', 'Caffe Latte', 'White Chocolate Mocha', 'Cramel Latte', 'Caffe Americano', 'Cappuccino', 'Espresso Truffle', 'Espresso con Panna', 'Peppermint Mocha Twist'];
						for (let i = 0; i < length; i++) {
							const row = {};
							row.firstName = firstNames[Math.floor(Math.random() * firstNames.length)];
							row.lastName = lastNames[Math.floor(Math.random() * lastNames.length)];
							row.birthday = new Date(Math.round(Math.random() * (2026 - 1926) + 1926), Math.round(Math.random() * 11), Math.round(Math.random() * (31 - 1) + 1));
							row.petName = petNames[Math.floor(Math.random() * petNames.length)];
							row.country = countries[Math.floor(Math.random() * countries.length)];
							row.productName = productNames[Math.floor(Math.random() * productNames.length)];
							row.price = parseFloat((Math.random() * (100 - 0.5) + 0.5).toFixed(2));
							row.quantity = Math.round(Math.random() * (50 - 1) + 1);
							row.timeOfPurchase = new Date(2026, 0, 1, Math.round(Math.random() * 23), Math.round(Math.random() * (31 - 1) + 1));
							row.expired = Math.random() >= 0.5;
							row.attachments = [];
							const maxAttachments = Math.floor(Math.random() * Math.floor(3)) + 1;
							for (let i = 0; i < maxAttachments; i++) {
								row.attachments.push("../../../images/travel/7.jpg");
							}
							row.attachments = row.attachments.join(',');
							sampleData[i] = row;
						}
						return sampleData;
					}(50)),
					dataFields: [
						'firstName: string',
						'lastName: string',
						'birthday: date',
						'petName: string',
						'country: string',
						'productName: string',
						'price: number',
						'quantity: number',
						'timeOfPurchase: date',
						'expired: boolean',
						'attachments: string'
					]
				}),
				columns: [
					{ label: 'First Name', dataField: 'firstName', icon: 'firstName' },
					{ label: 'Last Name', dataField: 'lastName', icon: 'lastName' },
					{ label: 'Birthday', dataField: 'birthday', icon: 'birthday', formatSettings: { formatString: 'd' } },
					{ label: 'Pet Name', dataField: 'petName', icon: 'petName' },
					{ label: 'Country', dataField: 'country', icon: 'country' },
					{ label: 'Product Name', dataField: 'productName', icon: 'productName' },
					{ label: 'Price', dataField: 'price', icon: 'price', formatSettings: { formatString: 'c2' } },
					{
						label: 'Quantity', dataField: 'quantity', icon: 'quantity'
					},
					{ label: 'Time of Purchase', dataField: 'timeOfPurchase', icon: 'timeOfPurchase', formatSettings: { formatString: 'hh:mm tt' } },
					{
						label: 'Expired', dataField: 'expired', icon: 'expired', formatFunction: function (settings) {
							settings.template = settings.value ? '☑' : '☐';
						}
					},
					{ label: 'Attachments', dataField: 'attachments', image: true }
				],
				coverField: 'attachments',
				titleField: 'firstName'
			};
	const myCardView = new Smart.CardView('#cardview', cardviewOptions);
	document.body.appendChild(myCardView);
	

Create with document.createElement('smart-card-view'), assign properties (same as any custom element), then append:

	const cardviewOptions = {
				dataSource: new Smart.DataAdapter({
					dataSource: (function generateData(length) {
						const sampleData = [], firstNames = ['Andrew', 'Nancy', 'Shelley', 'Regina', 'Yoshi', 'Antoni', 'Mayumi', 'Ian', 'Peter', 'Lars', 'Petra', 'Martin', 'Sven', 'Elio', 'Beate', 'Cheryl', 'Michael', 'Guylene'], lastNames = ['Fuller', 'Davolio', 'Burke', 'Murphy', 'Nagase', 'Saavedra', 'Ohno', 'Devling', 'Wilson', 'Peterson', 'Winkler', 'Bein', 'Petersen', 'Rossi', 'Vileid', 'Saylor', 'Bjorn', 'Nodier'], petNames = ['Sam', 'Bob', 'Lucky', 'Tommy', 'Charlie', 'Olliver', 'Mixie', 'Fluffy', 'Acorn', 'Beak'], countries = ['Bulgaria', 'USA', 'UK', 'Singapore', 'Thailand', 'Russia', 'China', 'Belize'], productNames = ['Black Tea', 'Green Tea', 'Caffe Espresso', 'Doubleshot Espresso', 'Caffe Latte', 'White Chocolate Mocha', 'Cramel Latte', 'Caffe Americano', 'Cappuccino', 'Espresso Truffle', 'Espresso con Panna', 'Peppermint Mocha Twist'];
						for (let i = 0; i < length; i++) {
							const row = {};
							row.firstName = firstNames[Math.floor(Math.random() * firstNames.length)];
							row.lastName = lastNames[Math.floor(Math.random() * lastNames.length)];
							row.birthday = new Date(Math.round(Math.random() * (2026 - 1926) + 1926), Math.round(Math.random() * 11), Math.round(Math.random() * (31 - 1) + 1));
							row.petName = petNames[Math.floor(Math.random() * petNames.length)];
							row.country = countries[Math.floor(Math.random() * countries.length)];
							row.productName = productNames[Math.floor(Math.random() * productNames.length)];
							row.price = parseFloat((Math.random() * (100 - 0.5) + 0.5).toFixed(2));
							row.quantity = Math.round(Math.random() * (50 - 1) + 1);
							row.timeOfPurchase = new Date(2026, 0, 1, Math.round(Math.random() * 23), Math.round(Math.random() * (31 - 1) + 1));
							row.expired = Math.random() >= 0.5;
							row.attachments = [];
							const maxAttachments = Math.floor(Math.random() * Math.floor(3)) + 1;
							for (let i = 0; i < maxAttachments; i++) {
								row.attachments.push("../../../images/travel/7.jpg");
							}
							row.attachments = row.attachments.join(',');
							sampleData[i] = row;
						}
						return sampleData;
					}(50)),
					dataFields: [
						'firstName: string',
						'lastName: string',
						'birthday: date',
						'petName: string',
						'country: string',
						'productName: string',
						'price: number',
						'quantity: number',
						'timeOfPurchase: date',
						'expired: boolean',
						'attachments: string'
					]
				}),
				columns: [
					{ label: 'First Name', dataField: 'firstName', icon: 'firstName' },
					{ label: 'Last Name', dataField: 'lastName', icon: 'lastName' },
					{ label: 'Birthday', dataField: 'birthday', icon: 'birthday', formatSettings: { formatString: 'd' } },
					{ label: 'Pet Name', dataField: 'petName', icon: 'petName' },
					{ label: 'Country', dataField: 'country', icon: 'country' },
					{ label: 'Product Name', dataField: 'productName', icon: 'productName' },
					{ label: 'Price', dataField: 'price', icon: 'price', formatSettings: { formatString: 'c2' } },
					{
						label: 'Quantity', dataField: 'quantity', icon: 'quantity'
					},
					{ label: 'Time of Purchase', dataField: 'timeOfPurchase', icon: 'timeOfPurchase', formatSettings: { formatString: 'hh:mm tt' } },
					{
						label: 'Expired', dataField: 'expired', icon: 'expired', formatFunction: function (settings) {
							settings.template = settings.value ? '☑' : '☐';
						}
					},
					{ label: 'Attachments', dataField: 'attachments', image: true }
				],
				coverField: 'attachments',
				titleField: 'firstName'
			};
	const cardview = document.createElement('smart-card-view');
	Object.assign(cardview, cardviewOptions);
	document.body.appendChild(cardview);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.cardview.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const cardviewOptions = {
				dataSource: new Smart.DataAdapter({
					dataSource: (function generateData(length) {
						const sampleData = [], firstNames = ['Andrew', 'Nancy', 'Shelley', 'Regina', 'Yoshi', 'Antoni', 'Mayumi', 'Ian', 'Peter', 'Lars', 'Petra', 'Martin', 'Sven', 'Elio', 'Beate', 'Cheryl', 'Michael', 'Guylene'], lastNames = ['Fuller', 'Davolio', 'Burke', 'Murphy', 'Nagase', 'Saavedra', 'Ohno', 'Devling', 'Wilson', 'Peterson', 'Winkler', 'Bein', 'Petersen', 'Rossi', 'Vileid', 'Saylor', 'Bjorn', 'Nodier'], petNames = ['Sam', 'Bob', 'Lucky', 'Tommy', 'Charlie', 'Olliver', 'Mixie', 'Fluffy', 'Acorn', 'Beak'], countries = ['Bulgaria', 'USA', 'UK', 'Singapore', 'Thailand', 'Russia', 'China', 'Belize'], productNames = ['Black Tea', 'Green Tea', 'Caffe Espresso', 'Doubleshot Espresso', 'Caffe Latte', 'White Chocolate Mocha', 'Cramel Latte', 'Caffe Americano', 'Cappuccino', 'Espresso Truffle', 'Espresso con Panna', 'Peppermint Mocha Twist'];
						for (let i = 0; i < length; i++) {
							const row = {};
							row.firstName = firstNames[Math.floor(Math.random() * firstNames.length)];
							row.lastName = lastNames[Math.floor(Math.random() * lastNames.length)];
							row.birthday = new Date(Math.round(Math.random() * (2026 - 1926) + 1926), Math.round(Math.random() * 11), Math.round(Math.random() * (31 - 1) + 1));
							row.petName = petNames[Math.floor(Math.random() * petNames.length)];
							row.country = countries[Math.floor(Math.random() * countries.length)];
							row.productName = productNames[Math.floor(Math.random() * productNames.length)];
							row.price = parseFloat((Math.random() * (100 - 0.5) + 0.5).toFixed(2));
							row.quantity = Math.round(Math.random() * (50 - 1) + 1);
							row.timeOfPurchase = new Date(2026, 0, 1, Math.round(Math.random() * 23), Math.round(Math.random() * (31 - 1) + 1));
							row.expired = Math.random() >= 0.5;
							row.attachments = [];
							const maxAttachments = Math.floor(Math.random() * Math.floor(3)) + 1;
							for (let i = 0; i < maxAttachments; i++) {
								row.attachments.push("../../../images/travel/7.jpg");
							}
							row.attachments = row.attachments.join(',');
							sampleData[i] = row;
						}
						return sampleData;
					}(50)),
					dataFields: [
						'firstName: string',
						'lastName: string',
						'birthday: date',
						'petName: string',
						'country: string',
						'productName: string',
						'price: number',
						'quantity: number',
						'timeOfPurchase: date',
						'expired: boolean',
						'attachments: string'
					]
				}),
				columns: [
					{ label: 'First Name', dataField: 'firstName', icon: 'firstName' },
					{ label: 'Last Name', dataField: 'lastName', icon: 'lastName' },
					{ label: 'Birthday', dataField: 'birthday', icon: 'birthday', formatSettings: { formatString: 'd' } },
					{ label: 'Pet Name', dataField: 'petName', icon: 'petName' },
					{ label: 'Country', dataField: 'country', icon: 'country' },
					{ label: 'Product Name', dataField: 'productName', icon: 'productName' },
					{ label: 'Price', dataField: 'price', icon: 'price', formatSettings: { formatString: 'c2' } },
					{
						label: 'Quantity', dataField: 'quantity', icon: 'quantity'
					},
					{ label: 'Time of Purchase', dataField: 'timeOfPurchase', icon: 'timeOfPurchase', formatSettings: { formatString: 'hh:mm tt' } },
					{
						label: 'Expired', dataField: 'expired', icon: 'expired', formatFunction: function (settings) {
							settings.template = settings.value ? '☑' : '☐';
						}
					},
					{ label: 'Attachments', dataField: 'attachments', image: true }
				],
				coverField: 'attachments',
				titleField: 'firstName'
			};
		const cardview = new Smart.CardView({
			...cardviewOptions,
			appendTo: '#cardviewContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('cardview-container');
container.appendChild(cardview);
	

Remove from the DOM:

cardview.remove();
	

Set a property:

cardview.disabled = true;
cardview.theme = 'dark';
	

Get a property value:

const isDisabled = cardview.disabled;
const currentTheme = cardview.theme;
	

Invoke a method:

cardview.refresh();
cardview.focus();
	

Add event listener:

cardview.addEventListener('open', (event) => {
    console.log('open triggered:', event.detail);
});
	

Remove event listener:

const handleCardViewEvent = (event) => {
    console.log('open triggered:', event.detail);
};

cardview.addEventListener('open', handleCardViewEvent);
cardview.removeEventListener('open', handleCardViewEvent);
	

Common Use Cases

  • Configure card layout

    Set columns and cover image field

    cardView.coverField = 'image';
    cardView.titleField = 'name';
  • Handle card click

    Respond when user clicks a card

    cardView.addEventListener('itemClick', (e) => {
      console.log('Card data:', e.detail.data);
    });

Troubleshooting

How do I customize card templates?
Use the cardTemplate property to define a custom HTML template with data bindings.

Accessibility

The CardView component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React CardView Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/cardview/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import ReactDOM from 'react-dom/client';
import { CardView } from 'smart-webcomponents-react/cardview';

const App = () => {
	const generateData = (length) => {
		const sampleData = [],
			firstNames = ['Andrew', 'Nancy', 'Shelley', 'Regina', 'Yoshi', 'Antoni', 'Mayumi', 'Ian', 'Peter', 'Lars', 'Petra', 'Martin', 'Sven', 'Elio', 'Beate', 'Cheryl', 'Michael', 'Guylene'],
			lastNames = ['Fuller', 'Davolio', 'Burke', 'Murphy', 'Nagase', 'Saavedra', 'Ohno', 'Devling', 'Wilson', 'Peterson', 'Winkler', 'Bein', 'Petersen', 'Rossi', 'Vileid', 'Saylor', 'Bjorn', 'Nodier'],
			petNames = ['Sam', 'Bob', 'Lucky', 'Tommy', 'Charlie', 'Olliver', 'Mixie', 'Fluffy', 'Acorn', 'Beak'],
			countries = ['Bulgaria', 'USA', 'UK', 'Singapore', 'Thailand', 'Russia', 'China', 'Belize'],
			productNames = ['Black Tea', 'Green Tea', 'Caffe Espresso', 'Doubleshot Espresso', 'Caffe Latte', 'White Chocolate Mocha', 'Cramel Latte', 'Caffe Americano', 'Cappuccino', 'Espresso Truffle', 'Espresso con Panna', 'Peppermint Mocha Twist'];
		for (let i = 0; i < length; i++) {
			const row = {};
			row.firstName = firstNames[Math.floor(Math.random() * firstNames.length)];
			row.lastName = lastNames[Math.floor(Math.random() * lastNames.length)];
			row.birthday = new Date(Math.round(Math.random() * (2018 - 1918) + 1918), Math.round(Math.random() * 11), Math.round(Math.random() * (31 - 1) + 1));
			row.petName = petNames[Math.floor(Math.random() * petNames.length)];
			row.country = countries[Math.floor(Math.random() * countries.length)];
			row.productName = productNames[Math.floor(Math.random() * productNames.length)];
			row.price = parseFloat((Math.random() * (100 - 0.5) + 0.5).toFixed(2));
			row.quantity = Math.round(Math.random() * (50 - 1) + 1);
			row.timeOfPurchase = new Date(2019, 0, 1, Math.round(Math.random() * 23), Math.round(Math.random() * (31 - 1) + 1));
			row.expired = Math.random() >= 0.5;
			row.attachments = [];
			const maxAttachments = Math.floor(Math.random() * Math.floor(3)) + 1;
			for (let i = 0; i < maxAttachments; i++) {
				row.attachments.push(`https://www.htmlelements.com/demos//images/travel/${Math.floor(Math.random() * 36) + 1}.jpg`);
			}
			row.attachments = row.attachments.join(',');
			sampleData[i] = row;
		}

		return sampleData;
	}

	const columns = [{
		label: 'First Name',
		dataField: 'firstName',
		icon: 'firstName'
	},
	{
		label: 'Last Name',
		dataField: 'lastName',
		icon: 'lastName'
	},
	{
		label: 'Birthday',
		dataField: 'birthday',
		icon: 'birthday',
		formatSettings: {
			formatString: 'd'
		}
	},
	{
		label: 'Pet Name',
		dataField: 'petName',
		icon: 'petName'
	},
	{
		label: 'Country',
		dataField: 'country',
		icon: 'country'
	},
	{
		label: 'Product Name',
		dataField: 'productName',
		icon: 'productName'
	},
	{
		label: 'Price',
		dataField: 'price',
		icon: 'price',
		formatSettings: {
			formatString: 'c2'
		}
	},
	{
		label: 'Quantity',
		dataField: 'quantity',
		icon: 'quantity',
		formatFunction: function (settings) {
			const value = settings.value;
			let className;
			if (value < 20) {
				className = 'red';
			} else if (value < 35) {
				className = 'yellow';
			} else {
				className = 'green';
			}
			settings.template = `<div class="${className}">${value}</div>`;
		}
	},
	{
		label: 'Time of Purchase',
		dataField: 'timeOfPurchase',
		icon: 'timeOfPurchase',
		formatSettings: {
			formatString: 'hh:mm tt'
		}
	},
	{
		label: 'Expired',
		dataField: 'expired',
		icon: 'expired',
		formatFunction: function (settings) {
			settings.template = settings.value ? '☑' : '☐';
		}
	},
	{
		label: 'Attachments',
		dataField: 'attachments',
		image: true
	}
	];

	const dataSource = generateData(50);
	const dataSourceSettings = {
		dataFields: [
			'firstName: string',
			'lastName: string',
			'birthday: date',
			'petName: string',
			'country: string',
			'productName: string',
			'price: number',
			'quantity: number',
			'timeOfPurchase: date',
			'expired: boolean',
			'attachments: string'
		]
	};

	return (
		<div>
			<div className="demo-description">In Card View, data source records are represented as cards. Each Card
				contain content and actions about a single subject. smartCardView supports
				data sort, data filtering, data editing, data grouping and data searching.</div>
			<CardView
				coverField="attachments"
				titleField="firstName"
				id="cardView"
				dataSourceSettings={dataSourceSettings}
				dataSource={dataSource}
				columns={columns}
			>
			</CardView>
		</div>
	);
}



export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Configure card layout

    Set columns and cover image field

    cardView.coverField = 'image';
    cardView.titleField = 'name';
  • Handle card click

    Respond when user clicks a card

    cardView.addEventListener('itemClick', (e) => {
      console.log('Card data:', e.detail.data);
    });

Troubleshooting

How do I customize card templates?
Use the cardTemplate property to define a custom HTML template with data bindings.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { CardView, CardViewProps } from 'smart-webcomponents-react/cardview';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The CardView component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular CardView - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/cardview/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import CardViewModule from smart-webcomponents-angular/cardview: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { CardViewModule } from 'smart-webcomponents-angular/cardview';

4 Root component (standalone)

Add CardViewModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { CardViewColumn, CardViewComponent, Smart } from 'smart-webcomponents-angular/cardview';

import { CardViewModule } from 'smart-webcomponents-angular/cardview';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ CardViewModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('cardview', { read: CardViewComponent, static: false }) cardview!: CardViewComponent;
    
    generateData(length: number): any[] {
        const sampleData = [], firstNames = ['Andrew', 'Nancy', 'Shelley', 'Regina', 'Yoshi', 'Antoni', 'Mayumi', 'Ian', 'Peter', 'Lars', 'Petra', 'Martin', 'Sven', 'Elio', 'Beate', 'Cheryl', 'Michael', 'Guylene'], lastNames = ['Fuller', 'Davolio', 'Burke', 'Murphy', 'Nagase', 'Saavedra', 'Ohno', 'Devling', 'Wilson', 'Peterson', 'Winkler', 'Bein', 'Petersen', 'Rossi', 'Vileid', 'Saylor', 'Bjorn', 'Nodier'], petNames = ['Sam', 'Bob', 'Lucky', 'Tommy', 'Charlie', 'Olliver', 'Mixie', 'Fluffy', 'Acorn', 'Beak'], countries = ['Bulgaria', 'USA', 'UK', 'Singapore', 'Thailand', 'Russia', 'China', 'Belize'], productNames = ['Black Tea', 'Green Tea', 'Caffe Espresso', 'Doubleshot Espresso', 'Caffe Latte', 'White Chocolate Mocha', 'Cramel Latte', 'Caffe Americano', 'Cappuccino', 'Espresso Truffle', 'Espresso con Panna', 'Peppermint Mocha Twist'];
        for (let i = 0; i < length; i++) {
            const row: any = {};
       
            row.firstName = (i + 1) + '. ' + firstNames[Math.floor(Math.random() * firstNames.length)];
            row.lastName = lastNames[Math.floor(Math.random() * lastNames.length)];
            row.birthday = new Date(Math.round(Math.random() * (2018 - 1918) + 1918), Math.round(Math.random() * 11), Math.round(Math.random() * (31 - 1) + 1));
            row.petName = petNames[Math.floor(Math.random() * petNames.length)];
            row.country = countries[Math.floor(Math.random() * countries.length)];
            row.productName = productNames[Math.floor(Math.random() * productNames.length)];
            row.price = parseFloat((Math.random() * (100 - 0.5) + 0.5).toFixed(2));
            row.quantity = Math.round(Math.random() * (50 - 1) + 1);
            row.timeOfPurchase = new Date(2019, 0, 1, Math.round(Math.random() * 23), Math.round(Math.random() * (31 - 1) + 1));
            row.expired = Math.random() >= 0.5;
            row.attachments = [];
            const maxAttachments = Math.floor(Math.random() * Math.floor(3)) + 1;
            for (let i = 0; i < maxAttachments; i++) {
                row.attachments.push(`../../../src/images/travel/${Math.floor(Math.random() * 36) + 1}.jpg`);
            }
            row.attachments = row.attachments.join(',');
            sampleData[i] = row;
        }
        
        return sampleData;
    }


    dataSource = new Smart.DataAdapter({
        dataSource: this.generateData(50),
        dataFields: [
            'firstName: string',
            'lastName: string',
            'birthday: date',
            'petName: string',
            'country: string',
            'productName: string',
            'price: number',
            'quantity: number',
            'timeOfPurchase: date',
            'expired: boolean',
            'attachments: string'
        ]
    });

    columns: CardViewColumn[] = [
        { label: 'First Name', dataField: 'firstName', icon: 'firstName' },
        { label: 'Last Name', dataField: 'lastName', icon: 'lastName' },
        { label: 'Birthday', dataField: 'birthday', icon: 'birthday', formatSettings: { formatString: 'd' } },
        { label: 'Pet Name', dataField: 'petName', icon: 'petName' },
        { label: 'Country', dataField: 'country', icon: 'country' },
        { label: 'Product Name', dataField: 'productName', icon: 'productName' },
        { label: 'Price', dataField: 'price', icon: 'price', formatSettings: { formatString: 'c2' } },
        {
            label: 'Quantity', dataField: 'quantity', icon: 'quantity', formatFunction: function (settings) {
                const value = settings.value;
                let className;
                if (value < 20) {
                    className = 'red';
                }
                else if (value < 35) {
                    className = 'yellow';
                }
                else {
                    className = 'green';
                }
                settings.template = `<div class="${className}">${value}</div>`;
            }
        },
        { label: 'Time of Purchase', dataField: 'timeOfPurchase', icon: 'timeOfPurchase', formatSettings: { formatString: 'hh:mm tt' } },
        {
            label: 'Expired', dataField: 'expired', icon: 'expired', formatFunction: function (settings) {
                settings.template = settings.value ? '☑' : '☐';
            }
        },
        { label: 'Attachments', dataField: 'attachments', image: true }
    ];

    coverField: string = 'attachments';
    titleField: string = 'firstName'
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-card-view as needed:

 <div class="demo-description">In Card View, data source records are represented as cards. Each Card
    contain content and actions about a single subject. smartCardView supports
    data sort, data filtering, data editing, data grouping and data searching.</div>
<smart-card-view [columns]="columns" [titleField]="titleField" [dataSource]="dataSource" [coverField]="coverField"
    #cardview id="cardView"></smart-card-view>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put CardViewModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put CardViewModule from smart-webcomponents-angular/cardview on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { CardViewModule } from 'smart-webcomponents-angular/cardview';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, CardViewModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Configure card layout

    Set columns and cover image field

    cardView.coverField = 'image';
    cardView.titleField = 'name';
  • Handle card click

    Respond when user clicks a card

    cardView.addEventListener('itemClick', (e) => {
      console.log('Card data:', e.detail.data);
    });

Troubleshooting

How do I customize card templates?
Use the cardTemplate property to define a custom HTML template with data bindings.

Accessibility

The CardView component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.